"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TitaniumFairplayContentProtectionIntegration = void 0;

var _TitaniumBaseRegistration = require("./TitaniumBaseRegistration");

var _TitaniumUtils = require("./TitaniumUtils");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class TitaniumFairplayContentProtectionIntegration {
  constructor(drmConfiguration) {
    _defineProperty(this, "contentProtectionConfiguration", void 0);

    if (!(0, _TitaniumUtils.isTitaniumDRMConfiguration)(drmConfiguration)) {
      throw new Error('Titanium DRM has not been correctly configured.');
    }

    this.contentProtectionConfiguration = drmConfiguration;
  }

  onLicenseRequest(request) {
    request.headers = { ...request.headers,
      ...(0, _TitaniumBaseRegistration.createTitaniumHeaders)(this.contentProtectionConfiguration, _TitaniumBaseRegistration.TitaniumCDMType.FAIRPLAY)
    };
    return request;
  }

  extractFairplayContentId(skdUrl) {
    // drop the 'skd://' part
    console.log(skdUrl);
    return skdUrl.substring(6, skdUrl.length);
  }

}

exports.TitaniumFairplayContentProtectionIntegration = TitaniumFairplayContentProtectionIntegration;
//# sourceMappingURL=TitaniumFairplayContentProtectionIntegration.js.map