"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TitaniumPlayReadyContentProtectionIntegration = void 0;

var _TitaniumBaseRegistration = require("./TitaniumBaseRegistration");

var _TitaniumUtils = require("./TitaniumUtils");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class TitaniumPlayReadyContentProtectionIntegration {
  constructor(drmConfiguration) {
    _defineProperty(this, "contentProtectionConfiguration", void 0);

    if (!(0, _TitaniumUtils.isTitaniumDRMConfiguration)(drmConfiguration)) {
      throw new Error('Titanium DRM has not been correctly configured.');
    }

    this.contentProtectionConfiguration = drmConfiguration;
  }

  onCertificateRequest(request) {
    request.headers = { ...request.headers,
      ...(0, _TitaniumBaseRegistration.createTitaniumHeaders)(this.contentProtectionConfiguration, _TitaniumBaseRegistration.TitaniumCDMType.PLAYREADY_v3)
    };
    return request;
  }

  onLicenseRequest(request) {
    request.headers = { ...request.headers,
      ...(0, _TitaniumBaseRegistration.createTitaniumHeaders)(this.contentProtectionConfiguration, _TitaniumBaseRegistration.TitaniumCDMType.PLAYREADY_v3)
    };
    return request;
  }

}

exports.TitaniumPlayReadyContentProtectionIntegration = TitaniumPlayReadyContentProtectionIntegration;
//# sourceMappingURL=TitaniumPlayReadyContentProtectionIntegration.js.map