"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTokenBasedTitaniumDRMConfiguration = exports.isTitaniumDRMConfiguration = exports.isDeviceBasedTitaniumDRMConfiguration = void 0;

const isTitaniumDRMConfiguration = configuration => {
  const integrationParameters = configuration.integrationParameters;
  return isTokenBasedTitaniumDRMConfiguration(integrationParameters) || isDeviceBasedTitaniumDRMConfiguration(integrationParameters);
};

exports.isTitaniumDRMConfiguration = isTitaniumDRMConfiguration;

const isTokenBasedTitaniumDRMConfiguration = integrationParameters => integrationParameters.authToken !== undefined;

exports.isTokenBasedTitaniumDRMConfiguration = isTokenBasedTitaniumDRMConfiguration;

const isDeviceBasedTitaniumDRMConfiguration = integrationParameters => integrationParameters.accountName !== undefined && integrationParameters.customerName !== undefined && integrationParameters.portalId !== undefined;

exports.isDeviceBasedTitaniumDRMConfiguration = isDeviceBasedTitaniumDRMConfiguration;
//# sourceMappingURL=TitaniumUtils.js.map