"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.THEOplayerNativeCastAPI = void 0;

var _reactNative = require("react-native");

var _THEOplayerNativeChromecast = require("./THEOplayerNativeChromecast");

var _THEOplayerNativeAirplay = require("./THEOplayerNativeAirplay");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class THEOplayerNativeCastAPI {
  constructor(_player) {
    this._player = _player;

    _defineProperty(this, "_chromecast", void 0);

    _defineProperty(this, "_airplay", void 0);

    this._chromecast = new _THEOplayerNativeChromecast.THEOplayerNativeChromecast(this._player);

    if (_reactNative.Platform.OS !== 'android') {
      this._airplay = new _THEOplayerNativeAirplay.THEOplayerNativeAirplay(this._player);
    }
  }

  casting() {
    return _reactNative.NativeModules.CastModule.casting(this._player.nativeHandle);
  }

  get chromecast() {
    return this._chromecast;
  }

  get airplay() {
    return this._airplay;
  }

}

exports.THEOplayerNativeCastAPI = THEOplayerNativeCastAPI;
//# sourceMappingURL=THEOplayerNativeCastApi.js.map