function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { createTitaniumHeaders, TitaniumCDMType } from './TitaniumBaseRegistration';
import { isTitaniumDRMConfiguration } from './TitaniumUtils';
export class TitaniumFairplayContentProtectionIntegration {
  constructor(drmConfiguration) {
    _defineProperty(this, "contentProtectionConfiguration", void 0);

    if (!isTitaniumDRMConfiguration(drmConfiguration)) {
      throw new Error('Titanium DRM has not been correctly configured.');
    }

    this.contentProtectionConfiguration = drmConfiguration;
  }

  onLicenseRequest(request) {
    request.headers = { ...request.headers,
      ...createTitaniumHeaders(this.contentProtectionConfiguration, TitaniumCDMType.FAIRPLAY)
    };
    return request;
  }

  extractFairplayContentId(skdUrl) {
    // drop the 'skd://' part
    console.log(skdUrl);
    return skdUrl.substring(6, skdUrl.length);
  }

}
//# sourceMappingURL=TitaniumFairplayContentProtectionIntegration.js.map