function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { createTitaniumHeaders, TitaniumCDMType } from './TitaniumBaseRegistration';
import { isTitaniumDRMConfiguration } from './TitaniumUtils';
export class TitaniumPlayReadyContentProtectionIntegration {
  constructor(drmConfiguration) {
    _defineProperty(this, "contentProtectionConfiguration", void 0);

    if (!isTitaniumDRMConfiguration(drmConfiguration)) {
      throw new Error('Titanium DRM has not been correctly configured.');
    }

    this.contentProtectionConfiguration = drmConfiguration;
  }

  onCertificateRequest(request) {
    request.headers = { ...request.headers,
      ...createTitaniumHeaders(this.contentProtectionConfiguration, TitaniumCDMType.PLAYREADY_v3)
    };
    return request;
  }

  onLicenseRequest(request) {
    request.headers = { ...request.headers,
      ...createTitaniumHeaders(this.contentProtectionConfiguration, TitaniumCDMType.PLAYREADY_v3)
    };
    return request;
  }

}
//# sourceMappingURL=TitaniumPlayReadyContentProtectionIntegration.js.map