function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { NativeModules, Platform } from 'react-native';
import { THEOplayerNativeChromecast } from './THEOplayerNativeChromecast';
import { THEOplayerNativeAirplay } from './THEOplayerNativeAirplay';
export class THEOplayerNativeCastAPI {
  constructor(_player) {
    this._player = _player;

    _defineProperty(this, "_chromecast", void 0);

    _defineProperty(this, "_airplay", void 0);

    this._chromecast = new THEOplayerNativeChromecast(this._player);

    if (Platform.OS !== 'android') {
      this._airplay = new THEOplayerNativeAirplay(this._player);
    }
  }

  casting() {
    return NativeModules.CastModule.casting(this._player.nativeHandle);
  }

  get chromecast() {
    return this._chromecast;
  }

  get airplay() {
    return this._airplay;
  }

}
//# sourceMappingURL=THEOplayerNativeCastApi.js.map