export const __esModule: boolean;
export const TitaniumCDMType: {} | undefined;
export let TitaniumCDMType: any;
export namespace TITANIUM_CDM_DESCRIPTIONS {
    namespace Widevine {
        const DRMProvider: string;
        const DRMVersion: string;
        const DRMType: string;
    }
    namespace PlayreadyV2 {
        const DRMProvider_1: string;
        export { DRMProvider_1 as DRMProvider };
        const DRMVersion_1: string;
        export { DRMVersion_1 as DRMVersion };
        const DRMType_1: string;
        export { DRMType_1 as DRMType };
    }
    namespace PlayreadyV3 {
        const DRMProvider_2: string;
        export { DRMProvider_2 as DRMProvider };
        const DRMVersion_2: string;
        export { DRMVersion_2 as DRMVersion };
        const DRMType_2: string;
        export { DRMType_2 as DRMType };
    }
    namespace Fairplay {
        const DRMProvider_3: string;
        export { DRMProvider_3 as DRMProvider };
        const DRMType_3: string;
        export { DRMType_3 as DRMType };
        const DRMVersion_3: string;
        export { DRMVersion_3 as DRMVersion };
    }
}
export function getTitaniumDeviceAuthorizationData(integrationParameters: any, cdmType: any): {
    LatensRegistration: {
        CustomerName: any;
        AccountName: any;
        PortalId: any;
        FriendlyName: any;
        AppVersion: string;
        DeviceInfo: {
            FormatVersion: string;
            DeviceType: string;
            OSType: string;
            OSVersion: string;
            DRMProvider: any;
            DRMVersion: any;
            DRMType: any;
            DeviceVendor: string;
            DeviceModel: string;
        };
    };
};
export function createErrorForMalformedDeviceInfoConfiguration(configuration: any, cdmType: any): never;
export function createErrorForMalformedTokenConfiguration(configuration: any, cdmType: any): never;
export function createTitaniumAuthHeader(configuration: any, cdmType: any): string;
export function createTitaniumDeviceHeader(configuration: any, cdmType: any): string;
export function createTitaniumHeaders(configuration: any, cdmType: any): {
    'content-type': string;
    Authorization: string;
    'X-TITANIUM-DRM-CDATA'?: undefined;
} | {
    'content-type': string;
    'X-TITANIUM-DRM-CDATA': string;
    Authorization?: undefined;
};
