import type { CastState, ChromecastError } from '@wouterds/react-native-theoplayer';
export declare const CastEventNames: readonly ["chromecaststatechange", "airplaystatechange", "chromecasterror"];
export declare type CastEventType = typeof CastEventNames[number];
export interface CastEvent {
    /**
     * Type of ad event.
     */
    readonly type: CastEventType;
}
export interface ChromecastChangeEvent extends CastEvent {
    readonly type: 'chromecaststatechange';
    readonly state: CastState;
}
export interface AirplayStateChangeEvent extends CastEvent {
    readonly type: 'airplaystatechange';
    readonly state: CastState;
}
export interface ChromecastErrorEvent extends CastEvent {
    readonly type: 'chromecasterror';
    readonly error: ChromecastError;
}
